﻿using AIWolf.Lib;

namespace WhiteWolf.Arrangement
{
    /// <summary>
    /// 2体のエージェントが両方狼かを表す条件
    /// </summary>
    public class BothWolfCondition : ICondition
    {
        private int isWerewolfBits;

        public BothWolfCondition(Agent agent1, Agent agent2)
        {
            isWerewolfBits = (1 << (agent1.AgentIdx - 1)) | (1 << (agent2.AgentIdx - 1));
        }

        public bool IsMatch(IPattern pattern)
        {
            return (isWerewolfBits & pattern.IsWerewolfBits) == isWerewolfBits;
        }
    }
}
