﻿using AIWolf.Lib;
using WhiteWolf.Arrangement;

namespace WhiteWolf.Guess
{
    /// <summary>
    /// 特定の内訳条件に対する推理。
    /// </summary>
    public interface IPartGuess
    {
        /// <summary>
        /// 内訳の判定
        /// </summary>
        bool IsMatchCondition(IPattern pattern);

        /// <summary>
        /// 内訳の尤度
        /// </summary>
        double Plausibility { get; }
    }

    /// <summary>
    /// 特定のエージェントに対する推理。
    /// 主に計算量の削減用。
    /// </summary>
    public interface IPartSingleAgentGuess : IPartGuess
    {
        Agent Agent { get; }
    }


}
