﻿using System;
using WhiteWolf.Arrangement;

namespace WhiteWolf.Guess
{
    class FreeConditionPartGuess : IPartGuess
    {
        public Func<IPattern, bool> Condition { get; }

        public double Plausibility { get; }

        public FreeConditionPartGuess(Func<IPattern, bool> condition, double plausibility)
        {
            Condition = condition;
            Plausibility = plausibility;
        }

        public bool IsMatchCondition(IPattern pattern)
        {
            return Condition(pattern);
        }
    }

    class ConditionPartGuess : IPartGuess
    {
        public ICondition Condition { get; }

        public double Plausibility { get; }

        public ConditionPartGuess(ICondition condition, double plausibility)
        {
            Condition = condition;
            Plausibility = plausibility;
        }

        public bool IsMatchCondition(IPattern pattern)
        {
            return Condition.IsMatch(pattern);
        }
    }
}
